AC_DEFUN(UTIL_TEST_CFLAGS,
		[AC_CACHE_CHECK([whether $CC supports $1], utils_cv_prog_cc_[]m4_translit([$1], [+=-], [p_]),  
								[cflags_saved=$CFLAGS
								CFLAGS="$1"
								AC_TRY_COMPILE([], [;], 
													[utils_cv_prog_cc_[]m4_translit([$1], [+=-], [p_])=yes], 
													[utils_cv_prog_cc_[]m4_translit([$1], [+=-], [p_])=no])
								CFLAGS=$cflags_saved
								]
						)
		if test "$utils_cv_prog_cc_[]m4_translit([$1], [+=-], [p_])" = "yes"; then
		   $2
		   :
		else
		   $3
		   :
		fi
		]
)

AC_DEFUN(UTIL_COMMON_CFLAGS,
[if test "$GCC" = "yes"; then
   PROFILE_CFLAGS='-pg -a'
   CFLAGS='-funsigned-char -Wall'
   OPTCFLAGS=-O2 
   if test "$ac_cv_prog_cc_g" = "yes"; then
      DEBUG_CFLAGS=-g 
   fi  	 
else
		CFLAGS=""
		case $host in
			 *-*-solaris*)
				UTIL_TEST_CFLAGS(-xCC, CFLAGS=-xCC)
				UTIL_TEST_CFLAGS(-pg, [PROFILE_CFLAGS=-pg],
									[UTIL_TEST_CFLAGS([-xpg],
											[PROFILE_CFLAGS='-xpg'],
											[UTIL_TEST_CFLAGS([-xprofile=collect],
												[PROFILE_CFLAGS='-xprofile=collect']
										)]
									)]
								)
				;;
			*-*-osf*)
				UTIL_TEST_CFLAGS(-unsigned, CFLAGS=-unsigned)
				UTIL_TEST_CFLAGS(-check, [CFLAGS="$CFLAGS -check"])
				UTIL_TEST_CFLAGS(-prof_gen, PROFILE_CFLAGS=-prof_gen)
				;;
			*-*-hpux*)
				UTIL_TEST_CFLAGS(+uc, CFLAGS=+uc)
				UTIL_TEST_CFLAGS(+w1, [CFLAGS="$CFLAGS +w1"])
				UTIL_TEST_CFLAGS(-G, PROFILE_CFLAGS=-G)
				UTIL_TEST_CFLAGS(+O2, OPTCFLAGS=+O2)
				;;
			*)
				;;
		esac
		if test -z "$OPTCFLAGS"; then
				UTIL_TEST_CFLAGS(-O2, OPTCFLAGS=-O2)
				if test -z "$OPTCFLAGS"; then
					UTIL_TEST_CFLAGS(-O, OPTCFLAGS=-O)
				fi
		fi
		if test -z "$DEBUG_CFLAGS"; then
		   if test "$ac_cv_prog_cc_g" = "yes"; then
			  DEBUG_CFLAGS=-g
		   fi
		fi
fi

AC_CACHE_CHECK([whether $CC supports C99 style comments], 
				util_cv_prog_cc_comments,
				[AC_TRY_COMPILE([], [ // comment
									],
									util_cv_prog_cc_comments=yes,
									util_cv_prog_cc_comments=no
									)
				] 
			   )
AC_C_CHAR_UNSIGNED

case $host in
	alpha*-*-freebsd*)
		enable_optimize=no
		;;
	*)
		enable_optimize=yes
		;;
esac

AC_ARG_ENABLE(optimize, AC_HELP_STRING([--disable-optimize], [don't use optimizing C compiler]))
if test "$enable_optimize" = "no"; then
   OPTCFLAGS=""
fi
AC_ARG_ENABLE(debug, AC_HELP_STRING([--disable-debug], [disable debugging info]),, enable_debug=yes)
if test "$enable_debug" != "no"; then
	AC_ARG_ENABLE(profile, AC_HELP_STRING([--enable-profile], [turn on profiling support]),, enable_profile=no)
	if test "$enable_profile" != "no"; then
		if test -z "$PROFILE_CFLAGS"; then
			AC_MSG_WARN([no profiling flags defined])
		else
			CFLAGS="$CFLAGS $PROFILE_CFLAGS"
		fi
	else
		CFLAGS="$CFLAGS $OPTCFLAGS"
	fi
	CFLAGS="$CFLAGS $DEBUG_CFLAGS"
else
	enable_profile=no
	CFLAGS="$CFLAGS $OPTCFLAGS"
fi
])
