/*
 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* $Id: sstream.h,v 1.3 2002/07/24 10:10:20 aa5779 Exp $ */
#ifndef SSTREAM_H
#define SSTREAM_H

#include "interp.h"
#include "util.h"

stream *ss_open(interpreter *i, char *name, char *sname, int writeable);
void ss_close(interpreter *i, stream *s);
html_chunk *ss_read(interpreter *i, stream *s);
void ss_writestr(interpreter *i, stream *s, char *str);
void ss_writetag(interpreter *i, stream *s, html_chunk *ch);
char *ss_ioctl(interpreter *i, stream *s, char *ctlstr);
int ss_getpos(interpreter *i, stream *s);
void ss_setpos(interpreter *i, stream *s, int p);
void ss_rewind(interpreter *i, stream *s);

#ifndef SSTREAM_IMP
extern stream_class script_stream_class;
#endif

#endif

